shell真难。。看以下shell Script。。。

sh/bash/dash/ksh/zsh等Shell脚本
回复
LinuxPing
帖子: 47
注册时间: 2006-03-21 16:21

shell真难。。看以下shell Script。。。

#1

帖子 LinuxPing » 2006-04-10 1:12

#!/bin/sh

set -e

# We don't use a secret keyring, of course, but gpg panics and
# implodes if there isn't one available

GPG_CMD="gpg --no-options --no-default-keyring --secret-keyring /etc/apt/secring.gpg --trustdb-name /etc/apt/trustdb.gpg"
GPG="$GPG_CMD --keyring /etc/apt/trusted.gpg"


ARCHIVE_KEYRING=/usr/share/keyrings/ubuntu-archive-keyring.gpg
REMOVED_KEYS=/usr/share/keyrings/ubuntu-archive-removed-keys.gpg


update() {
if [ ! -f $ARCHIVE_KEYRING ]; then
echo >&2 "ERROR: Can't find the archive-keyring"
echo >&2 "Is the ubuntu-keyring package installed?"
exit 1
fi

# add new keys
$GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --ignore-time-conflict --import

# remove no-longer used keys
keys=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys|awk '/^pub/{FS=":";print $5}'`
for key in $keys; do
if $GPG --list-keys --with-colons | awk '/^pub/{FS=":";print $5}'|grep -q $key; then
$GPG --quiet --batch --delete-key --yes ${key}
fi
done
}

usage() {
echo "Usage: apt-key [command] [arguments]"
echo
echo "Manage apt's list of trusted keys"
echo
echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
echo " apt-key del <keyid> - remove the key <keyid>"
echo " apt-key update - update keys using the keyring package"
echo " apt-key list - list keys"
echo
}

command="$1"
if [ -z "$command" ]; then
usage
exit 1
fi
shift

if [ "$command" != "help" ] && ! which gpg >/dev/null 2>&1; then
echo >&2 "Warning: gnupg does not seem to be installed."
echo >&2 "Warning: apt-key requires gnupg for most operations."
echo >&2
fi

case "$command" in
add)
$GPG --quiet --batch --import "$1"
echo "OK"
;;
del|rm|remove)
$GPG --quiet --batch --delete-key --yes "$1"
echo "OK"
;;
update)
update
;;
list)
$GPG --batch --list-keys
;;
finger*)
$GPG --batch --fingerprint
;;
adv*)
echo "Executing: $GPG $*"
$GPG $*
;;
help)
usage
;;
*)
usage
exit 1
;;
esac
LinuxPing
帖子: 47
注册时间: 2006-03-21 16:21

#2

帖子 LinuxPing » 2006-04-10 1:30

我的问题很多,下面都是的:
1 set -e 是什么意思?
2 GPG_CMD="gpg --no-options --no-。。。。。。。。。“' 不知道什么意思。
3 echo >&2 "ERROR: Can't find the archive-keyring" echo 和错误 把它们重定向到标准输出??
4 if $GPG --list-keys --with-colons | awk '/^pub/{FS=":";print $5}'|grep -q $key; then awk '/^pub/{FS=":";print $5}'好复杂啊!^pub是什么意思?
头像
leal
帖子: 1119
注册时间: 2005-08-29 14:49
来自: 杭州
联系:

#3

帖子 leal » 2006-04-10 10:41

1. man set
2. man gpg
3. 如果未指定错误输出文件,则输出到屏幕
4. man awk ^pub 指得是 以pub 起始的行


shell本身比较简单,重要的是如何活用一大堆现成的小工具,并把它们组合起来
用心×恒 | 豆瓣 | 门户 | Blog
回复